// XpaDemoClearCallDlg.cpp : implementation file
//

#include "stdafx.h"
#include "XpaDemo.h"

#include "XpipeAPI.h"				// XpipeAPI stuff

#include "XpaDemoClearCallDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoClearCallDlg dialog


CXpaDemoClearCallDlg::CXpaDemoClearCallDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXpaDemoClearCallDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXpaDemoClearCallDlg)
	m_cause = 0;
	m_clearData = _T("");
	m_diagnostic = 0;
	m_lcn = 1;
	m_status = _T("");
	//}}AFX_DATA_INIT

	// display the dialog ...
	Create(IDD_XPADEMO_CLEARCALL_DIALOG, pParent);
}


void CXpaDemoClearCallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXpaDemoClearCallDlg)
	DDX_Text(pDX, IDC_CLRCALLCAUSE, m_cause);
	DDX_Text(pDX, IDC_CLRCALLDATA, m_clearData);
	DDV_MaxChars(pDX, m_clearData, 1027);
	DDX_Text(pDX, IDC_CLRCALLDIAG, m_diagnostic);
	DDX_Text(pDX, IDC_CLRCALLLCN, m_lcn);
	DDV_MinMaxInt(pDX, m_lcn, 1, 4096);
	DDX_Text(pDX, IDC_STATUS, m_status);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CXpaDemoClearCallDlg, CDialog)
	//{{AFX_MSG_MAP(CXpaDemoClearCallDlg)
	ON_BN_CLICKED(IDC_CLOSE, OnCloseClicked)
	ON_BN_CLICKED(IDC_CLRCALL, OnClearCallClicked)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoClearCallDlg message handlers

//
// "Clear Call" button clicked
//
void CXpaDemoClearCallDlg::OnClearCallClicked() 
{
	int		iRVal;			// return value from the call

	// pick up the call data
	UpdateData( TRUE );

	if (0 != (iRVal=xpaClearCall(1, m_lcn, (char*)(LPCTSTR)m_clearData, TRUE, m_cause, m_diagnostic))) {
		// failure ...
		m_status.Format("Failed to clear call. Return code 0x%02X, last error %d", iRVal, xpaGetLastError());
	} else {
		// success ... 
		m_status.Format("Call cleared on logical channel %d - channel is no longer valid", m_lcn);
	}
	// update dialog data
	UpdateData( FALSE );
	return;
}

//
// "Close" button clicked
//
void CXpaDemoClearCallDlg::OnCloseClicked() 
{
	DestroyWindow();

	// since we created the dialog on heap - we need to delete it as well
	delete this;
}
