// XpaDemoClearReqDlg.cpp : implementation file
//

#include "stdafx.h"
#include "XpaDemo.h"

#include "XpipeAPI.h"					// XpipeAPI stuff

#include "XpaDemoClearReqDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoClearReqDlg dialog


CXpaDemoClearReqDlg::CXpaDemoClearReqDlg(int Lcn, XPA_MSG_DATA *pCallData, CWnd* pParent /*=NULL*/)
	: CDialog(CXpaDemoClearReqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXpaDemoClearReqDlg)
	m_cause = _T("");
	m_clearData = _T("");
	m_diagnostic = _T("");
	m_lcn = _T("");
	//}}AFX_DATA_INIT

	// 
	// set up dialog data
	//

	// logical channel
	m_lcn.Format("%d", Lcn);
	// clear data
	if (pCallData->buffer_length) {
		m_clearData.Format("%s", pCallData->data);
	}
	// cause 
	m_cause.Format("%d", pCallData->cause);
	// diagnostic
	m_diagnostic.Format("%d", pCallData->diagnostic);

	// notify API that we've processed WMXPA_ASY_CLEARREQ message so it can 
	// free the message data
	xpaMsgComplete( pCallData );

	// display the dialog ...
	Create(IDD_XPADEMO_CLEARREQ_DIALOG, pParent);
}


void CXpaDemoClearReqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXpaDemoClearReqDlg)
	DDX_Text(pDX, IDC_CAUSE, m_cause);
	DDX_Text(pDX, IDC_CLEARDATA, m_clearData);
	DDX_Text(pDX, IDC_DIAGNOSTIC, m_diagnostic);
	DDX_Text(pDX, IDC_LCN, m_lcn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CXpaDemoClearReqDlg, CDialog)
	//{{AFX_MSG_MAP(CXpaDemoClearReqDlg)
	ON_BN_CLICKED(IDC_CLRCLOSE, OnCloseClicked)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoClearReqDlg message handlers

//
// "Close" button clicked
//
void CXpaDemoClearReqDlg::OnCloseClicked() 
{
	DestroyWindow();

	// since we created the dialog on heap - we need to delete it as well
	delete this;
}
