// XpaDemoPlaceCallDlg.cpp : implementation file
//

#include "stdafx.h"
#include "XpaDemo.h"

#include "XpipeAPI.h"				// XpipeAPI stuff

#include "XpaDemoPlaceCallDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Prototype for display clear array - see XpaDemoDlg.cpp for details
extern BOOL	gDisplayClearReq[];

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoPlaceCallDlg dialog


CXpaDemoPlaceCallDlg::CXpaDemoPlaceCallDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXpaDemoPlaceCallDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXpaDemoPlaceCallDlg)
	m_callData = _T("");
	m_dBit = FALSE;
	m_status = _T("");
	//}}AFX_DATA_INIT
	m_lcn = 0;
	// display the dialog ...
	Create(IDD_XPADEMO_PLACECALL_DIALOG, pParent);
}


void CXpaDemoPlaceCallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXpaDemoPlaceCallDlg)
	DDX_Text(pDX, IDC_CALLDATA, m_callData);
	DDV_MaxChars(pDX, m_callData, 1027);
	DDX_Check(pDX, IDC_DBIT, m_dBit);
	DDX_Text(pDX, IDC_STATUS, m_status);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CXpaDemoPlaceCallDlg, CDialog)
	//{{AFX_MSG_MAP(CXpaDemoPlaceCallDlg)
	ON_BN_CLICKED(IDC_CLOSE, OnCloseClicked)
	ON_BN_CLICKED(IDC_PLACECALL, OnPlaceCallClicked)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WMXPA_ASY_CONNECTED, OnConnected)	// Call Accepted/Connected
	ON_MESSAGE(WMXPA_ASY_CLEARREQ, OnClearReq)		// Clear Request/Indication
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXpaDemoPlaceCallDlg message handlers

//
// "Place Call" button clicked handler
//
void CXpaDemoPlaceCallDlg::OnPlaceCallClicked() 
{
	int		Lcn;			// returned logical channel number
	int		iRVal;			// return value from the call

	// pick up the call data
	UpdateData( TRUE );

	//if D-bit checkbox is checked set the D-bit in m_dBit.
	if(m_dBit == 0x01)	m_dBit = 0x02;
	
	if (0 != (iRVal=xpaPlaceCall(1, &Lcn, (char*)(LPCTSTR)m_callData, m_dBit))) {
		// failure ...
		m_status.Format("Failed to place call. Return code 0x%02X, last error %d", iRVal, xpaGetLastError());
	} else {
		// success ... display status and register this window to receive call confirmation
		m_status.Format("Placed call on logical channel %d", Lcn);
		xpaRegisterWindow( m_hWnd, 1, Lcn );
		// also remember the lcn and indicate that we will take care of Clear Requests
		m_lcn = Lcn;
		gDisplayClearReq[m_lcn] = FALSE;
	}
	// update dialog data
	UpdateData( FALSE );
	return;
}

//
// "Close" button clicked handler
//
void CXpaDemoPlaceCallDlg::OnCloseClicked() 
{
	// tell the main window that it will have to take care of Clear Requests 
	if (m_lcn) gDisplayClearReq[m_lcn] = TRUE;

	// deregister this window from XpipeAPI - note that the function always works
	// even if the window wasn't actually registered.
	xpaDeregisterWindow( m_hWnd, 1 );
	
	// destroy the dialog 
	DestroyWindow();

	// since we created the dialog on heap - we need to delete it as well
	delete this;
}

//
//	WMXPA_ASY_CONNECTED handler
//
afx_msg LRESULT CXpaDemoPlaceCallDlg::OnConnected(WPARAM wParam, LPARAM lParam)
{
	// display status 
	m_status.Format("Call accepted on logical channel %d - channel is ready", wParam);
	UpdateData( FALSE );

	// notify API we've proccessed the message
	xpaMsgComplete( (XPA_MSG_DATA *)lParam );
	return 0;
}

//
//  WMXPA_ASY_CLEARREQ handler
//
afx_msg LRESULT CXpaDemoPlaceCallDlg::OnClearReq(WPARAM wParam, LPARAM lParam)
{
	// display status 
	m_status.Format("Call rejected on logical channel %d - channel is no longer valid", wParam);
	UpdateData( FALSE );

	// notify API we've proccessed the message
	xpaMsgComplete( (XPA_MSG_DATA *)lParam );
	return 0;
}

//
// Default message handler - we need it to handle correctly all unhandled 
// WMXPA_ messages ...
//
LRESULT CXpaDemoPlaceCallDlg::DefWindowProc( UINT message, WPARAM wParam, LPARAM lParam )
{
	if ((message >= WMXPA_ASY_INCALL) && (message <= WMXPA_RXDATA)) {
		// notify the API that we've processed the message 
		xpaMsgComplete( (XPA_MSG_DATA *)lParam );
	}
	// call the parent class 
	return CDialog::DefWindowProc( message, wParam, lParam );
}

